unit RaymonPJQImpl;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActiveX, AxCtrls, RaymonPJQ_TLB, StdVcl, StdCtrls, HIDEvaMachine;

type
  TRaymonPJQX = class(TActiveForm, IRaymonPJQX)
  private
    { Private declarations }
    FEvents: IRaymonPJQXEvents;
    procedure ActivateEvent(Sender: TObject);
    procedure ClickEvent(Sender: TObject);
    procedure CreateEvent(Sender: TObject);
    procedure DblClickEvent(Sender: TObject);
    procedure DeactivateEvent(Sender: TObject);
    procedure DestroyEvent(Sender: TObject);
    procedure KeyPressEvent(Sender: TObject; var Key: Char);
    procedure MouseEnterEvent(Sender: TObject);
    procedure MouseLeaveEvent(Sender: TObject);
    procedure PaintEvent(Sender: TObject);
  protected
    { Protected declarations }
    procedure DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage); override;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    function Get_Active: WordBool; safecall;
    function Get_AlignDisabled: WordBool; safecall;
    function Get_AlignWithMargins: WordBool; safecall;
    function Get_AutoScroll: WordBool; safecall;
    function Get_AutoSize: WordBool; safecall;
    function Get_AxBorderStyle: TxActiveFormBorderStyle; safecall;
    function Get_Caption: WideString; safecall;
    function Get_Color: OLE_COLOR; safecall;
    function Get_DockSite: WordBool; safecall;
    function Get_DoubleBuffered: WordBool; safecall;
    function Get_DropTarget: WordBool; safecall;
    function Get_Enabled: WordBool; safecall;
    function Get_ExplicitHeight: Integer; safecall;
    function Get_ExplicitLeft: Integer; safecall;
    function Get_ExplicitTop: Integer; safecall;
    function Get_ExplicitWidth: Integer; safecall;
    function Get_Font: IFontDisp; safecall;
    function Get_HelpFile: WideString; safecall;
    function Get_KeyPreview: WordBool; safecall;
    function Get_MouseInClient: WordBool; safecall;
    function Get_PixelsPerInch: Integer; safecall;
    function Get_PopupMode: TxPopupMode; safecall;
    function Get_PrintScale: TxPrintScale; safecall;
    function Get_Scaled: WordBool; safecall;
    function Get_ScreenSnap: WordBool; safecall;
    function Get_SnapBuffer: Integer; safecall;
    function Get_UseDockManager: WordBool; safecall;
    function Get_Visible: WordBool; safecall;
    function Get_VisibleDockClientCount: Integer; safecall;
    procedure _Set_Font(var Value: IFontDisp); safecall;
    procedure Set_AlignWithMargins(Value: WordBool); safecall;
    procedure Set_AutoScroll(Value: WordBool); safecall;
    procedure Set_AutoSize(Value: WordBool); safecall;
    procedure Set_AxBorderStyle(Value: TxActiveFormBorderStyle); safecall;
    procedure Set_Caption(const Value: WideString); safecall;
    procedure Set_Color(Value: OLE_COLOR); safecall;
    procedure Set_DockSite(Value: WordBool); safecall;
    procedure Set_DoubleBuffered(Value: WordBool); safecall;
    procedure Set_DropTarget(Value: WordBool); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_Font(const Value: IFontDisp); safecall;
    procedure Set_HelpFile(const Value: WideString); safecall;
    procedure Set_KeyPreview(Value: WordBool); safecall;
    procedure Set_PixelsPerInch(Value: Integer); safecall;
    procedure Set_PopupMode(Value: TxPopupMode); safecall;
    procedure Set_PrintScale(Value: TxPrintScale); safecall;
    procedure Set_Scaled(Value: WordBool); safecall;
    procedure Set_ScreenSnap(Value: WordBool); safecall;
    procedure Set_SnapBuffer(Value: Integer); safecall;
    procedure Set_UseDockManager(Value: WordBool); safecall;
    procedure Set_Visible(Value: WordBool); safecall;
    function getKey(timeout: Integer): Byte; safecall;
    function reset: Byte; safecall;
    procedure sendStars(stars: Integer); safecall;
    procedure start; safecall;
    function setReady: WordBool; safecall;
  public
    { Public declarations }
    procedure Initialize; override;
  end;

implementation

uses ComObj, ComServ;

{$R *.DFM}

{ TRaymonPJQX }

procedure TRaymonPJQX.DefinePropertyPages(DefinePropertyPage: TDefinePropertyPage);
begin
  { Define property pages here.  Property pages are defined by calling
    DefinePropertyPage with the class id of the page.  For example,
      DefinePropertyPage(Class_RaymonPJQXPage); }
end;

procedure TRaymonPJQX.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IRaymonPJQXEvents;
  inherited EventSinkChanged(EventSink);
end;

procedure TRaymonPJQX.Initialize;
begin
  inherited Initialize;
  OnActivate := ActivateEvent;
  OnClick := ClickEvent;
  OnCreate := CreateEvent;
  OnDblClick := DblClickEvent;
  OnDeactivate := DeactivateEvent;
  OnDestroy := DestroyEvent;
  OnKeyPress := KeyPressEvent;
  OnMouseEnter := MouseEnterEvent;
  OnMouseLeave := MouseLeaveEvent;
  OnPaint := PaintEvent;
end;

function TRaymonPJQX.Get_Active: WordBool;
begin
  Result := Active;
end;

function TRaymonPJQX.Get_AlignDisabled: WordBool;
begin
  Result := AlignDisabled;
end;

function TRaymonPJQX.Get_AlignWithMargins: WordBool;
begin
  Result := AlignWithMargins;
end;

function TRaymonPJQX.Get_AutoScroll: WordBool;
begin
  Result := AutoScroll;
end;

function TRaymonPJQX.Get_AutoSize: WordBool;
begin
  Result := AutoSize;
end;

function TRaymonPJQX.Get_AxBorderStyle: TxActiveFormBorderStyle;
begin
  Result := Ord(AxBorderStyle);
end;

function TRaymonPJQX.Get_Caption: WideString;
begin
  Result := WideString(Caption);
end;

function TRaymonPJQX.Get_Color: OLE_COLOR;
begin
  Result := OLE_COLOR(Color);
end;

function TRaymonPJQX.Get_DockSite: WordBool;
begin
  Result := DockSite;
end;

function TRaymonPJQX.Get_DoubleBuffered: WordBool;
begin
  Result := DoubleBuffered;
end;

function TRaymonPJQX.Get_DropTarget: WordBool;
begin
  Result := DropTarget;
end;

function TRaymonPJQX.Get_Enabled: WordBool;
begin
  Result := Enabled;
end;

function TRaymonPJQX.Get_ExplicitHeight: Integer;
begin
  Result := ExplicitHeight;
end;

function TRaymonPJQX.Get_ExplicitLeft: Integer;
begin
  Result := ExplicitLeft;
end;

function TRaymonPJQX.Get_ExplicitTop: Integer;
begin
  Result := ExplicitTop;
end;

function TRaymonPJQX.Get_ExplicitWidth: Integer;
begin
  Result := ExplicitWidth;
end;

function TRaymonPJQX.Get_Font: IFontDisp;
begin
  GetOleFont(Font, Result);
end;

function TRaymonPJQX.Get_HelpFile: WideString;
begin
  Result := WideString(HelpFile);
end;

function TRaymonPJQX.Get_KeyPreview: WordBool;
begin
  Result := KeyPreview;
end;

function TRaymonPJQX.Get_MouseInClient: WordBool;
begin
  Result := MouseInClient;
end;

function TRaymonPJQX.Get_PixelsPerInch: Integer;
begin
  Result := PixelsPerInch;
end;

function TRaymonPJQX.Get_PopupMode: TxPopupMode;
begin
  Result := Ord(PopupMode);
end;

function TRaymonPJQX.Get_PrintScale: TxPrintScale;
begin
  Result := Ord(PrintScale);
end;

function TRaymonPJQX.Get_Scaled: WordBool;
begin
  Result := Scaled;
end;

function TRaymonPJQX.Get_ScreenSnap: WordBool;
begin
  Result := ScreenSnap;
end;

function TRaymonPJQX.Get_SnapBuffer: Integer;
begin
  Result := SnapBuffer;
end;

function TRaymonPJQX.Get_UseDockManager: WordBool;
begin
  Result := UseDockManager;
end;

function TRaymonPJQX.Get_Visible: WordBool;
begin
  Result := Visible;
end;

function TRaymonPJQX.Get_VisibleDockClientCount: Integer;
begin
  Result := VisibleDockClientCount;
end;

procedure TRaymonPJQX._Set_Font(var Value: IFontDisp);
begin
  SetOleFont(Font, Value);
end;

procedure TRaymonPJQX.ActivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnActivate;
end;

procedure TRaymonPJQX.ClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnClick;
end;

procedure TRaymonPJQX.CreateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnCreate;
end;

procedure TRaymonPJQX.DblClickEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDblClick;
end;

procedure TRaymonPJQX.DeactivateEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDeactivate;
end;

procedure TRaymonPJQX.DestroyEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnDestroy;
end;

procedure TRaymonPJQX.KeyPressEvent(Sender: TObject; var Key: Char);
var
  TempKey: Smallint;
begin
  TempKey := Smallint(Key);
  if FEvents <> nil then FEvents.OnKeyPress(TempKey);
  Key := Char(TempKey);
end;

procedure TRaymonPJQX.MouseEnterEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnMouseEnter;
end;

procedure TRaymonPJQX.MouseLeaveEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnMouseLeave;
end;

procedure TRaymonPJQX.PaintEvent(Sender: TObject);
begin
  if FEvents <> nil then FEvents.OnPaint;
end;

procedure TRaymonPJQX.Set_AlignWithMargins(Value: WordBool);
begin
  AlignWithMargins := Value;
end;

procedure TRaymonPJQX.Set_AutoScroll(Value: WordBool);
begin
  AutoScroll := Value;
end;

procedure TRaymonPJQX.Set_AutoSize(Value: WordBool);
begin
  AutoSize := Value;
end;

procedure TRaymonPJQX.Set_AxBorderStyle(Value: TxActiveFormBorderStyle);
begin
  AxBorderStyle := TActiveFormBorderStyle(Value);
end;

procedure TRaymonPJQX.Set_Caption(const Value: WideString);
begin
  Caption := TCaption(Value);
end;

procedure TRaymonPJQX.Set_Color(Value: OLE_COLOR);
begin
  Color := TColor(Value);
end;

procedure TRaymonPJQX.Set_DockSite(Value: WordBool);
begin
  DockSite := Value;
end;

procedure TRaymonPJQX.Set_DoubleBuffered(Value: WordBool);
begin
  DoubleBuffered := Value;
end;

procedure TRaymonPJQX.Set_DropTarget(Value: WordBool);
begin
  DropTarget := Value;
end;

procedure TRaymonPJQX.Set_Enabled(Value: WordBool);
begin
  Enabled := Value;
end;

procedure TRaymonPJQX.Set_Font(const Value: IFontDisp);
begin
  SetOleFont(Font, Value);
end;

procedure TRaymonPJQX.Set_HelpFile(const Value: WideString);
begin
  HelpFile := string(Value);
end;

procedure TRaymonPJQX.Set_KeyPreview(Value: WordBool);
begin
  KeyPreview := Value;
end;

procedure TRaymonPJQX.Set_PixelsPerInch(Value: Integer);
begin
  PixelsPerInch := Value;
end;

procedure TRaymonPJQX.Set_PopupMode(Value: TxPopupMode);
begin
  PopupMode := TPopupMode(Value);
end;

procedure TRaymonPJQX.Set_PrintScale(Value: TxPrintScale);
begin
  PrintScale := TPrintScale(Value);
end;

procedure TRaymonPJQX.Set_Scaled(Value: WordBool);
begin
  Scaled := Value;
end;

procedure TRaymonPJQX.Set_ScreenSnap(Value: WordBool);
begin
  ScreenSnap := Value;
end;

procedure TRaymonPJQX.Set_SnapBuffer(Value: Integer);
begin
  SnapBuffer := Value;
end;

procedure TRaymonPJQX.Set_UseDockManager(Value: WordBool);
begin
  UseDockManager := Value;
end;

procedure TRaymonPJQX.Set_Visible(Value: WordBool);
begin
  Visible := Value;
end;

function TRaymonPJQX.getKey(timeout: Integer): Byte;
var
  fem: TEvaluationMachine;
begin
  result := 0;
  fem := TEvaluationMachine.Create;
  if not fem.setReady then begin
    exit;
  end;
  fem.sendVoiceMessage(2);
  result := fem.getEvaluation(timeOut);
  fem.Free;
end;

function TRaymonPJQX.reset: Byte;
var
  fem: TEvaluationMachine;
begin
  result := 0;
  fem := TEvaluationMachine.Create;
  if not fem.setReady then begin
    exit;
  end;
  fem.reset;
  result := 1;
  fem.Free;
end;

procedure TRaymonPJQX.sendStars(stars: Integer);
var
  fem: TEvaluationMachine;
begin
  fem := TEvaluationMachine.Create;
  if not fem.setReady then begin
    exit;
  end;
  fem.sendStarLevel(stars);
  fem.Free;
end;

procedure TRaymonPJQX.start;
var
  fem: TEvaluationMachine;
begin
  //result := 0;
  fem := TEvaluationMachine.Create;
  if not fem.setReady then begin
    exit;
  end;
 // result := 1;
  fem.sendVoiceMessage(1);
  fem.Free;
end;

function TRaymonPJQX.setReady: WordBool;
var
  fem: TEvaluationMachine;
begin
  fem := TevaluationMachine.Create;
  Result := fem.setReady;
  fem.Free;
end;

initialization
  TActiveFormFactory.Create(
    ComServer,
    TActiveFormControl,
    TRaymonPJQX,
    Class_RaymonPJQX,
    1,
    '',
    OLEMISC_SIMPLEFRAME or OLEMISC_ACTSLIKELABEL,
    tmApartment);
end.
