
// HID_PJQDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "HID_PJQ.h"
#include "HID_PJQDlg.h"
#include "dbt.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CHID_PJQDlg Ի


CHID_PJQDlg::CHID_PJQDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHID_PJQDlg::IDD, pParent)
	, m_DeviceStatus(_T(""))
	, m_Evaluation(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHID_PJQDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_DeviceStatus);
	DDX_Control(pDX, IDC_SLIDER1, m_StarSlider);
	DDX_Text(pDX, IDC_EVARESULT, m_Evaluation);
}

BEGIN_MESSAGE_MAP(CHID_PJQDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_CONNECT, &CHID_PJQDlg::OnBnClickedConnect)
	ON_BN_CLICKED(IDC_WELCOME, &CHID_PJQDlg::OnBnClickedWelcome)
	ON_BN_CLICKED(IDC_DISCONNECT, &CHID_PJQDlg::OnBnClickedDisconnect)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_EVALUATE, &CHID_PJQDlg::OnBnClickedEvaluate)
	ON_BN_CLICKED(IDC_THANK, &CHID_PJQDlg::OnBnClickedThank)
END_MESSAGE_MAP()


// CHID_PJQDlg Ϣ

BOOL CHID_PJQDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	RegisterNotification();            // dialog box will be notified whenever
	                                   // a USB device is attached or removed
	                                   // from the USB

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	ShowWindow(SW_MINIMIZE);

	Init_Variables();

	return TRUE;  // ǽõؼ򷵻 TRUE
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CHID_PJQDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CHID_PJQDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



//-----------------------------------------------------------------------------
// NOTIFICATION ROUTINES
//-----------------------------------------------------------------------------
//
// These routines enable the dialog box to monitor and respond to USB
// devices being connected to and disconnected from the USB.

//-----------------------------------------------------------------------------
// RegisterNotification
//-----------------------------------------------------------------------------
//
// Routine registers the notification handle so that device
// connect/disconnect information  initiates a call
// to the OnDeviceChange routine.  This allows the system to
// respond to devices being connected or unexpectedly removed
// from the USB.
//
void CHID_PJQDlg::RegisterNotification()
{
	// Register device notification
	DEV_BROADCAST_DEVICEINTERFACE devIF = {0};
	GUID		hidGuid;

	GetHidGuid(&hidGuid);

	devIF.dbcc_size = sizeof(devIF);
	devIF.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE;
	devIF.dbcc_classguid  = hidGuid;

	m_hNotifyDevNode = RegisterDeviceNotification(GetSafeHwnd(),
		&devIF, DEVICE_NOTIFY_WINDOW_HANDLE);
}

//-----------------------------------------------------------------------------
// UnregisterNotification
//-----------------------------------------------------------------------------
//
// Routine unregisters the notification handle so that device
// connect/disconnect information no longer initiates a call
// to the OnDeviceChange routine.
//
void CHID_PJQDlg::UnregisterNotification()
{
	// Unegister device notification
	if(NULL != m_hNotifyDevNode)
	{
		UnregisterDeviceNotification(m_hNotifyDevNode);
		m_hNotifyDevNode = INVALID_HANDLE_VALUE;
	}
}

//-----------------------------------------------------------------------------
// OnDeviceChange
//-----------------------------------------------------------------------------
//
// Routine is called whenever the dialog box receives notification that
// a device has either been attached to or removed from USB.  This fuction
// requires that the function RegisterNotification has been executed
// to operate properly.
//
BOOL CHID_PJQDlg::OnDeviceChange(UINT nEventType, DWORD dwData)
{
	switch(nEventType)
	{
		// A device has been inserted and is now available.
		case DBT_DEVICEARRIVAL:
			// Check to see if newly connected device has VID and PID
			// matching Hid_Pjq's VID and PID
			if (Pjq.IsConnected())
			{
				// Update Device Status text
				m_DeviceStatus = "Connected, Idle";
				UpdateData (FALSE);
			}
			break;

		// A device has been removed from USB.
		case DBT_DEVICEREMOVECOMPLETE:

			// Check that the Hid_Pjq device was the removed device
			if (!Pjq.IsConnected())
			{
				// Call routine that will terminate communication and
				// destroy a receive thread, if one has been created

				m_DeviceStatus = "Disconnected";
				UpdateData (FALSE);
			}
			break;

		default:
			break;
	}

	return TRUE;
}

void CHID_PJQDlg::OnBnClickedConnect()
{
	if(Pjq.IsConnected()) {
		Pjq.Open();
		if(Pjq.IsOpened()) {
			m_DeviceStatus = "Connected, Active";
		} else {
			m_DeviceStatus = "Connected, Failed";
		}
	} else {
		m_DeviceStatus = "Disconnected";
	}
	UpdateData(FALSE);
}

void CHID_PJQDlg::Init_Variables() {
	// If this call returns a non-zero value, the device is connected
	if (Pjq.IsConnected())
	{
		// Device is connected, but communication has not been
		// "activated"
		m_DeviceStatus = "Connected, Idle";
	}
	else
	{
		// No device is currently attached to USB that matches
		// the PID and VID
		m_DeviceStatus = "Disconnected";
	}
	UpdateData(FALSE);
	m_StarLevel = 0;
	m_StarSlider.SetRange(0, 5);
	m_StarSlider.SetPos(0);
}


void CHID_PJQDlg::OnBnClickedWelcome()
{
	Pjq.Welcome();
}

void CHID_PJQDlg::OnBnClickedDisconnect()
{
	Pjq.Close();
	Init_Variables();
}

void CHID_PJQDlg::SetStar(BYTE starLevel) {
	Pjq.SetStar(starLevel);
}

void CHID_PJQDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	if((pScrollBar->GetDlgCtrlID() == IDC_SLIDER1) && (nSBCode == SB_THUMBTRACK)) {
		SetStar((BYTE)nPos);
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CHID_PJQDlg::OnBnClickedEvaluate()
{
	BYTE key = Pjq.Evaluate();
	m_Evaluation.Format(_T("KEY: %d"), key);
	UpdateData(FALSE);
}

void CHID_PJQDlg::OnBnClickedThank()
{
	Pjq.Thanks();
}
